diff --git a/reviewboard/hostingsvcs/tests/test_codebasehq.py b/reviewboard/hostingsvcs/tests/test_codebasehq.py
index 50705c7758a791e058514cfff145d46c30ceed4b..36b3b43a18529f75546c3f01de4bfc4c96d180a8 100644
--- a/reviewboard/hostingsvcs/tests/test_codebasehq.py
+++ b/reviewboard/hostingsvcs/tests/test_codebasehq.py
@@ -1,5 +1,8 @@
 """Unit tests for the Codebase HQ hosting service."""
 
+from __future__ import annotations
+
+from reviewboard.hostingsvcs.codebasehq import CodebaseHQ
 from reviewboard.hostingsvcs.errors import RepositoryError
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 from reviewboard.scmtools.crypto_utils import (decrypt_password,
@@ -7,7 +10,7 @@
 from reviewboard.scmtools.errors import FileNotFoundError
 
 
-class CodebaseHQTests(HostingServiceTestCase):
+class CodebaseHQTests(HostingServiceTestCase[CodebaseHQ]):
     """Unit tests for the Codebase HQ hosting service."""
 
     service_name = 'codebasehq'
@@ -24,13 +27,13 @@
         'codebasehq_repo_name': 'myrepo',
     }
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing CodebaseHQ service support capabilities"""
         self.assertFalse(self.service_class.supports_post_commit)
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertTrue(self.service_class.supports_repositories)
 
-    def test_get_repository_fields_for_git(self):
+    def test_get_repository_fields_for_git(self) -> None:
         """Testing CodebaseHQ.get_repository_fields for Git"""
         self.assertEqual(
             self.get_repository_fields(
@@ -44,7 +47,7 @@
                 'path': 'git@codebasehq.com:mydomain/myproj/myrepo.git',
             })
 
-    def test_get_repository_fields_for_mercurial(self):
+    def test_get_repository_fields_for_mercurial(self) -> None:
         """Testing CodebaseHQ.get_repository_fields for Mercurial"""
         self.assertEqual(
             self.get_repository_fields(
@@ -59,7 +62,7 @@
                          'myproj/repositories/myrepo/'),
             })
 
-    def test_get_repository_fields_for_subversion(self):
+    def test_get_repository_fields_for_subversion(self) -> None:
         """Testing CodebaseHQ.get_repository_fields for Subversion"""
         self.assertEqual(
             self.get_repository_fields(
@@ -73,7 +76,7 @@
                 'path': 'https://mydomain.codebasehq.com/myproj/myrepo.svn',
             })
 
-    def test_get_bug_tracker_field(self):
+    def test_get_bug_tracker_field(self) -> None:
         """Testing CodebaseHQ.get_bug_tracker_field"""
         self.assertEqual(
             self.service_class.get_bug_tracker_field(
@@ -84,22 +87,22 @@
                 }),
             'https://mydomain.codebasehq.com/projects/myproj/tickets/%s')
 
-    def test_check_repository_git(self):
+    def test_check_repository_git(self) -> None:
         """Testing CodebaseHQ.check_repository for Git"""
         self._test_check_repository(codebase_scm_type='git',
                                     tool_name='Git')
 
-    def test_check_repository_mercurial(self):
+    def test_check_repository_mercurial(self) -> None:
         """Testing CodebaseHQ.check_repository for Mercurial"""
         self._test_check_repository(codebase_scm_type='hg',
                                     tool_name='Mercurial')
 
-    def test_check_repository_subversion(self):
+    def test_check_repository_subversion(self) -> None:
         """Testing CodebaseHQ.check_repository for Subversion"""
         self._test_check_repository(codebase_scm_type='svn',
                                     tool_name='Subversion')
 
-    def test_check_repository_with_mismatching_type(self):
+    def test_check_repository_with_mismatching_type(self) -> None:
         """Testing CodebaseHQ.check_repository with mismatching repository type
         """
         self._test_check_repository(codebase_scm_type='svn',
@@ -107,7 +110,7 @@
                                     expect_success=False,
                                     expected_name_for_error='Subversion')
 
-    def test_authorize(self):
+    def test_authorize(self) -> None:
         """Testing CodebaseHQ.authorize"""
         hosting_account = self.create_hosting_account(data={})
 
@@ -142,86 +145,89 @@
                          'mypass')
         self.assertTrue(ctx.service.is_authorized())
 
-    def test_get_file_with_mercurial(self):
+    def test_get_file_with_mercurial(self) -> None:
         """Testing CodebaseHQ.get_file with Mercurial"""
         self._test_get_file(tool_name='Mercurial')
 
-    def test_get_file_with_mercurial_not_found(self):
+    def test_get_file_with_mercurial_not_found(self) -> None:
         """Testing CodebaseHQ.get_file with Mercurial with file not found"""
         self._test_get_file(tool_name='Mercurial', file_exists=False)
 
-    def test_get_file_with_git(self):
+    def test_get_file_with_git(self) -> None:
         """Testing CodebaseHQ.get_file with Git"""
         self._test_get_file(tool_name='Git', expect_git_blob_url=True)
 
-    def test_get_file_with_git_not_found(self):
+    def test_get_file_with_git_not_found(self) -> None:
         """Testing CodebaseHQ.get_file with Git with file not found"""
         self._test_get_file(tool_name='Git', expect_git_blob_url=True,
                             file_exists=False)
 
-    def test_get_file_with_subversion(self):
+    def test_get_file_with_subversion(self) -> None:
         """Testing CodebaseHQ.get_file with Subversion"""
         self._test_get_file(tool_name='Subversion')
 
-    def test_get_file_with_subversion_not_found(self):
+    def test_get_file_with_subversion_not_found(self) -> None:
         """Testing CodebaseHQ.get_file with Subversion with file not found"""
         self._test_get_file(tool_name='Subversion', file_exists=False)
 
-    def test_get_file_exists_with_mercurial(self):
+    def test_get_file_exists_with_mercurial(self) -> None:
         """Testing CodebaseHQ.get_file_exists with Mercurial"""
         self._test_get_file_exists(tool_name='Mercurial')
 
-    def test_get_file_exists_with_mercurial_not_found(self):
+    def test_get_file_exists_with_mercurial_not_found(self) -> None:
         """Testing CodebaseHQ.get_file_exists with Mercurial with file not
         found
         """
         self._test_get_file_exists(tool_name='Mercurial', file_exists=False)
 
-    def test_get_file_exists_with_git(self):
+    def test_get_file_exists_with_git(self) -> None:
         """Testing CodebaseHQ.get_file_exists with Git"""
         self._test_get_file_exists(tool_name='Git', expect_git_blob_url=True)
 
-    def test_get_file_exists_with_git_not_found(self):
+    def test_get_file_exists_with_git_not_found(self) -> None:
         """Testing CodebaseHQ.get_file_exists with Git with file not found"""
         self._test_get_file_exists(tool_name='Git', expect_git_blob_url=True,
                                    file_exists=False)
 
-    def test_get_file_exists_with_subversion(self):
+    def test_get_file_exists_with_subversion(self) -> None:
         """Testing CodebaseHQ.get_file_exists with Subversion"""
         self._test_get_file_exists(tool_name='Subversion')
 
-    def test_get_file_exists_with_subversion_not_found(self):
+    def test_get_file_exists_with_subversion_not_found(self) -> None:
         """Testing CodebaseHQ.get_file_exists with Subversion with file not
         found
         """
         self._test_get_file_exists(tool_name='Subversion', file_exists=False)
 
-    def _test_check_repository(self, codebase_scm_type, tool_name,
-                               expect_success=True,
-                               expected_name_for_error=None):
+    def _test_check_repository(
+        self,
+        codebase_scm_type: str,
+        tool_name: str,
+        expect_success: bool = True,
+        expected_name_for_error: (str | None) = None,
+    ) -> None:
         """Test repository checks.
 
         Args:
-            codebase_scm_type (unicode):
+            codebase_scm_type (str):
                 The name of the SCM type in the CodebaseHQ API to return in
                 payloads.
 
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
             expect_success (bool, optional):
                 Whether to simulate a truthy response.
 
-            expected_name_for_error (unicode, optional):
+            expected_name_for_error (str, optional):
                 The name of the SCM Tool to expect in the error response,
                 if ``expect_success`` is ``False``.
         """
         payload = (
-            '<?xml version="1.0" encoding="UTF-8"?>\n'
-            '<repository>\n'
-            ' <scm>%s</scm>\n'
-            '</repository>\n'
-            % codebase_scm_type
+            f'<?xml version="1.0" encoding="UTF-8"?>\n'
+            f'<repository>\n'
+            f' <scm>{codebase_scm_type}</scm>\n'
+            f'</repository>\n'
         ).encode('utf-8')
 
         check_repository_kwargs = {
@@ -236,9 +242,8 @@
                 ctx.service.check_repository(**check_repository_kwargs)
             else:
                 message = (
-                    "The repository type doesn't match what you selected. Did "
-                    "you mean %s?"
-                    % expected_name_for_error
+                    f"The repository type doesn't match what you selected. "
+                    f'Did you mean {expected_name_for_error}?'
                 )
 
                 with self.assertRaisesMessage(RepositoryError, message):
@@ -253,12 +258,16 @@
                 'Accept': 'application/xml',
             })
 
-    def _test_get_file(self, tool_name, expect_git_blob_url=False,
-                       file_exists=True):
+    def _test_get_file(
+        self,
+        tool_name: str,
+        expect_git_blob_url: bool = False,
+        file_exists: bool = True,
+    ) -> None:
         """Test file fetching.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
             expect_git_blob_url (bool, optional):
@@ -309,12 +318,16 @@
                 'Accept': 'application/xml',
             })
 
-    def _test_get_file_exists(self, tool_name, expect_git_blob_url=False,
-                              file_exists=True):
+    def _test_get_file_exists(
+        self,
+        tool_name: str,
+        expect_git_blob_url: bool = False,
+        file_exists: bool = True,
+    ) -> None:
         """Test file existence checks.
 
         Args:
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCM Tool to test with.
 
             expect_git_blob_url (bool, optional):
diff --git a/reviewboard/hostingsvcs/tests/test_fogbugz.py b/reviewboard/hostingsvcs/tests/test_fogbugz.py
index af2f7c50414382a9ee374786cf1bbaaac01f8869..8ee2f2b4c8c2f6160aa82584e0e7d09d90139935 100644
--- a/reviewboard/hostingsvcs/tests/test_fogbugz.py
+++ b/reviewboard/hostingsvcs/tests/test_fogbugz.py
@@ -1,20 +1,23 @@
 """Unit tests for the FogBugz hosting service."""
 
+from __future__ import annotations
+
+from reviewboard.hostingsvcs.fogbugz import FogBugz
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 
 
-class FogBugzTests(HostingServiceTestCase):
+class FogBugzTests(HostingServiceTestCase[FogBugz]):
     """Unit tests for the FogBugz hosting service."""
 
     service_name = 'fogbugz'
     fixtures = ['test_scmtools']
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing FogBugz service support capabilities"""
         self.assertTrue(self.service_class.supports_bug_trackers)
         self.assertFalse(self.service_class.supports_repositories)
 
-    def test_get_bug_tracker_field(self):
+    def test_get_bug_tracker_field(self) -> None:
         """Testing FogBugz.get_bug_tracker_field"""
         self.assertFalse(
             self.service_class.get_bug_tracker_requires_username())
diff --git a/reviewboard/hostingsvcs/tests/test_gerrit.py b/reviewboard/hostingsvcs/tests/test_gerrit.py
index 590395f62a67c98deee9aaee5a4111a9864f38b3..ecefd2aacbe513d26e9322e7fc5523174de37e9c 100644
--- a/reviewboard/hostingsvcs/tests/test_gerrit.py
+++ b/reviewboard/hostingsvcs/tests/test_gerrit.py
@@ -1,22 +1,32 @@
 """Unit tests for the Gerrit hosting service."""
 
+from __future__ import annotations
+
 import base64
 import re
 import sys
+from typing import TYPE_CHECKING, cast
 from urllib.request import HTTPDigestAuthHandler, OpenerDirector
 
 from reviewboard.hostingsvcs.errors import (AuthorizationError,
                                             HostingServiceAPIError,
                                             HostingServiceError,
                                             RepositoryError)
-from reviewboard.hostingsvcs.gerrit import Gerrit, GerritForm
+from reviewboard.hostingsvcs.gerrit import Gerrit, GerritClient, GerritForm
 from reviewboard.hostingsvcs.testing import HostingServiceTestCase
 from reviewboard.scmtools.core import Branch, Commit
 from reviewboard.scmtools.crypto_utils import encrypt_password
 from reviewboard.scmtools.errors import FileNotFoundError
 
-
-class GerritTestCase(HostingServiceTestCase):
+if TYPE_CHECKING:
+    from typing import NoReturn
+
+    from typelets.json import JSONValue
+
+    from reviewboard.hostingsvcs.testing.testcases import HttpTestPath
+
+
+class GerritTestCase(HostingServiceTestCase[Gerrit]):
     """Base class for Gerrit unit tests."""
 
     service_name = 'gerrit'
@@ -38,7 +48,7 @@
 class GerritFormTests(GerritTestCase):
     """Unit tests for GerritForm."""
 
-    def test_clean_sets_gerrit_domain(self):
+    def test_clean_sets_gerrit_domain(self) -> None:
         """Testing GerritForm.clean sets gerrit_domain"""
         form = GerritForm(
             {
@@ -53,7 +63,7 @@
         self.assertEqual(form.cleaned_data['gerrit_domain'],
                          'gerrit.example.com')
 
-    def test_clean_with_errors(self):
+    def test_clean_with_errors(self) -> None:
         """Testing GerritForm.clean with errors"""
         form = GerritForm(
             {
@@ -77,32 +87,35 @@
 class GerritClientTests(GerritTestCase):
     """Unit tests for GerritClient."""
 
-    def setUp(self):
-        super(GerritClientTests, self).setUp()
+    client: GerritClient
+
+    def setUp(self) -> None:
+        """Set up the test case."""
+        super().setUp()
 
         hosting_account = self.create_hosting_account()
-        self.client = hosting_account.service.client
+        self.client = cast(GerritClient, hosting_account.service.client)
 
-    def test_auth_headers(self):
+    def test_auth_headers(self) -> None:
         """Testing GerritClient.http_request sets auth headers"""
-        class DummyResponse(object):
+        class DummyResponse:
             headers = {}
 
-            def getcode(self):
+            def getcode(self) -> int:
                 return 200
 
-            def geturl(self):
+            def geturl(self) -> str:
                 return 'http://gerrit.example.com/'
 
-            def read(self):
+            def read(self) -> bytes:
                 return b''
 
-        def _open(*args, **kwargs):
-            _open_args.extend(args)
+        def _open(*args, **kwargs) -> DummyResponse:
+            open_args.extend(args)
 
             return DummyResponse()
 
-        _open_args = []
+        open_args = []
         self.spy_on(OpenerDirector.open,
                     owner=OpenerDirector,
                     call_fake=_open)
@@ -111,7 +124,7 @@
                                  username='test-user',
                                  password='test-pass')
 
-        opener, request = _open_args
+        opener, request = open_args
         handler = opener.handlers[0]
         self.assertIsInstance(handler, HTTPDigestAuthHandler)
         self.assertEqual(
@@ -144,14 +157,14 @@
         'gerrit_project_name': 'Project',
     }
 
-    def test_service_support(self):
+    def test_service_support(self) -> None:
         """Testing Gerrit service support capabilities"""
         self.assertFalse(self.service_class.supports_bug_trackers)
         self.assertTrue(self.service_class.supports_repositories)
         self.assertFalse(self.service_class.supports_ssh_key_association)
         self.assertTrue(self.service_class.supports_post_commit)
 
-    def test_authorize(self):
+    def test_authorize(self) -> None:
         """Testing Gerrit.authorize"""
         hosting_account = self.create_hosting_account(data={})
 
@@ -173,7 +186,7 @@
 
         ctx.assertHTTPCall(0, url='http://gerrit.example.com/a/projects/')
 
-    def test_authorize_with_error(self):
+    def test_authorize_with_error(self) -> None:
         """Testing Gerrit.authorize handles authentication failure"""
         expected_message = (
             'Unable to authenticate to Gerrit at '
@@ -181,7 +194,11 @@
             'used may be invalid.'
         )
 
-        def _http_request(client, *args, **kwargs):
+        def _http_request(
+            client: GerritClient,
+            *args,
+            **kwargs,
+        ) -> NoReturn:
             raise HostingServiceError('', http_code=401)
 
         with self.setup_http_test(_http_request, expected_http_calls=1) as ctx:
@@ -202,7 +219,7 @@
 
         self.assertFalse(ctx.hosting_account.data['authorized'])
 
-    def test_check_repository(self):
+    def test_check_repository(self) -> None:
         """Testing Gerrit.check_repository"""
         payload = self._make_json_rsp({
             'gerrit-reviewboard': {
@@ -221,9 +238,13 @@
                            url='http://gerrit.example.com/a/projects/Project')
         ctx.assertHTTPCall(1, url='http://gerrit.example.com/a/plugins/')
 
-    def test_check_repository_with_404(self):
+    def test_check_repository_with_404(self) -> None:
         """Testing Gerrit.check_repository with a non-existent repository"""
-        def _http_request(client, *args, **kwargs):
+        def _http_request(
+            client: GerritClient,
+            *args,
+            **kwargs,
+        ) -> NoReturn:
             raise HostingServiceAPIError('', 404)
 
         expected_message = (
@@ -241,7 +262,7 @@
         ctx.assertHTTPCall(0,
                            url='http://gerrit.example.com/a/projects/Project')
 
-    def test_check_repository_with_no_plugin(self):
+    def test_check_repository_with_no_plugin(self) -> None:
         """Testing Gerrit.check_repository with no plugin"""
         expected_message = (
             'The "gerrit-reviewboard" plugin is not installed on the server. '
@@ -260,7 +281,7 @@
                            url='http://gerrit.example.com/a/projects/Project')
         ctx.assertHTTPCall(1, url='http://gerrit.example.com/a/plugins/')
 
-    def test_check_repository_with_bad_plugin_version(self):
+    def test_check_repository_with_bad_plugin_version(self) -> None:
         """Testing Gerrit.check_repository with an outdated plugin"""
         payload = self._make_json_rsp({
             'gerrit-reviewboard': {
@@ -286,7 +307,7 @@
                            url='http://gerrit.example.com/a/projects/Project')
         ctx.assertHTTPCall(1, url='http://gerrit.example.com/a/plugins/')
 
-    def test_get_file_exists(self):
+    def test_get_file_exists(self) -> None:
         """Testing Gerrit.get_file_exists"""
         blob_id = 'a' * 40
 
@@ -306,9 +327,13 @@
             url=('http://gerrit.example.com/a/projects/Project/blobs/%s/'
                  % blob_id))
 
-    def test_get_file_exists_with_404(self):
+    def test_get_file_exists_with_404(self) -> None:
         """Testing Gerrit.get_file_exists with a non-existent file"""
-        def _http_request(client, *args, **kwargs):
+        def _http_request(
+            client: GerritClient,
+            *args,
+            **kwargs,
+        ) -> NoReturn:
             raise HostingServiceAPIError('', http_code=404)
 
         blob_id = 'a' * 40
@@ -324,7 +349,7 @@
             url=('http://gerrit.example.com/a/projects/Project/blobs/%s/'
                  % blob_id))
 
-    def test_get_file(self):
+    def test_get_file(self) -> None:
         """Testing Gerrit.get_file"""
         blob_id = 'a' * 40
 
@@ -343,9 +368,13 @@
                  'content/'
                  % blob_id))
 
-    def test_get_file_with_404(self):
+    def test_get_file_with_404(self) -> None:
         """Testing Gerrit.get_file with a non-existent blob ID"""
-        def _http_request(client, *args, **kwargs):
+        def _http_request(
+            client: GerritClient,
+            *args,
+            **kwargs,
+        ) -> NoReturn:
             raise HostingServiceAPIError('', http_code=404)
 
         blob_id = 'a' * 40
@@ -362,7 +391,7 @@
                  'content/'
                  % blob_id))
 
-    def test_get_file_with_undecodable_response(self):
+    def test_get_file_with_undecodable_response(self) -> None:
         """Testing Gerrit.get_file with an undecodable response"""
         blob_id = 'a' * 40
 
@@ -394,7 +423,7 @@
                  'content/'
                  % blob_id))
 
-    def test_get_branches(self):
+    def test_get_branches(self) -> None:
         """Testing Gerrit.get_branches"""
         payload = self._make_json_rsp([
             {
@@ -440,7 +469,7 @@
             ]
         )
 
-    def test_get_commits(self):
+    def test_get_commits(self) -> None:
         """Testing Gerrit.get_commits"""
         payload = self._make_json_rsp([
             {
@@ -504,10 +533,10 @@
         for commit in commits:
             self.assertIsNone(commit.diff)
 
-    def test_get_change(self):
+    def test_get_change(self) -> None:
         """Testing Gerrit.get_change"""
         revision = '77c174669b7018936f16b98547445624c6738e1e'
-        paths = {
+        paths: dict[str | None, HttpTestPath] = {
             '/a/projects/Project/commits/%s/diff/' % revision: {
                 'payload': b'fake diff',
             },
@@ -550,7 +579,10 @@
             url=('http://gerrit.example.com/a/projects/Project/commits/'
                  '77c174669b7018936f16b98547445624c6738e1e/diff/'))
 
-    def _make_json_rsp(self, data):
+    def _make_json_rsp(
+        self,
+        data: JSONValue,
+    ) -> bytes:
         """Return a Gerrit JSON response payload for the given data.
 
         Args:
